#!/usr/bin/perl -w

@TransactionTypes=('REQUEST_PROJECT_CREATE', 'NOTIFY_PROJECT_CREATE',
	'REQUEST_PROJECT_RESOURCES', 'NOTIFY_PROJECT_RESOURCES',
	'REQUEST_PROJECT_MODIFY', 'NOTIFY_PROJECT_MODIFY',
	'REQUEST_PROJECT_INACTIVATE', 'NOTIFY_PROJECT_INACTIVATE',
	'REQUEST_PROJECT_REACTIVATE', 'NOTIFY_PROJECT_REACTIVATE',
	'REQUEST_ACCOUNT_CREATE', 'NOTIFY_ACCOUNT_CREATE',
	'REQUEST_ACCOUNT_INACTIVATE', 'NOTIFY_ACCOUNT_INACTIVATE',
	'REQUEST_ACCOUNT_REACTIVATE', 'NOTIFY_ACCOUNT_REACTIVATE',
	'REQUEST_USER_SUSPEND', 'NOTIFY_USER_SUSPEND',
	'REQUEST_USER_REACTIVATE', 'NOTIFY_USER_REACTIVATE',
	'REQUEST_USER_MODIFY', 'NOTIFY_USER_MODIFY',
	'INFORM_PROJECT', 'INFORM_ACCOUNT',
	'INFORM_TRANSACTION_COMPLETE',
	'NOTIFY_PROJECT_USAGE');

@TransactionFields=('alliance_psn', 'project_title', 'pfos', 'sfos', 
	'mach_num',
	'alloc', 'start_date', 'end_date', 'grant_num', 'last_name',
	'first_name', 'middle_name', 'ssn', 'partner_id', 'partner_psn', 
	'abstract', 'alloc_type', 'alloc_change', 'effective_date',
	'sector', 'qualifications', 'methodologies', 'support',
	'other_resources', 'statement_work', 'background', 'justification',
        'deliverables', 'milestones', 'progress', 'facilities', 'languages',
	'applications', 'diskspace', 'memory', 'processors',
	'title',
	'first_name', 'middle_name', 'last_name', 
	'organization', 'org_code', 'emp_code',
	'dept', 'position', 'off_address', 'str_address', 'str_address2', 
	'city', 'state', 'zip', 'country', 'bus_phone', 'bus_ext', 'bus_com',
	'home_phone', 'home_ext', 'home_com', 'fax', 'email', 
	'country_access', 'req_login',
	'citizenship', 'nsf_status_code', 'les_login', 'partner_login', 'dn',
	'role', 'pi_account',
	'kerberos', 'sc_level', 
	'related_transaction_type', 'status_code', 'detail_code', 'message',
	'related_transaction_id', 'reason_code', 
	'new_dn', 'valid_cert',
	'comment');

@ListSupportedFields=('mach_num', 'country_access', 'req_login');

### REQUIRED AND OPTIONAL FIELDS FOR THE VARIOUS TRANSACTIONS ###
# REQUEST_PROJECT_CREATE
@RequiredFields[0]=['alliance_psn', 'alloc_type', 'su_alloc', 
	'last_name', 'first_name', 'middle_name', 'email',
	'start_date', 'end_date', 'project_title', 'pfos', 'sfos',
	'title', 'organization', 'citizenship', 'country_access',
	'mach_num', 'pi_account', 'ssn'];
@OptionalFields[0]=['partner_id', 'grant_num', 'abstract', 
	'sector', 'qualifications', 'methodologies', 'support',
	'other_resources', 'statement_work', 'background', 'justification',
        'deliverables', 'milestones', 'progress', 'facilities', 'languages',
	'applications', 'diskspace', 'memory', 'processors', 
	'dn', 'off_address', 'str_address', 'str_address2',
	'city', 'state', 'zip', 'country',
	'bus_phone', 'bus_ext', 'bus_com',
	'home_phone', 'home_ext', 'home_com',
	'fax', 'partner_login', 'les_login', 'req_login',
	'org_code', 'emp_code', 'dept', 'position',
	'kerberos', 'sc_level', 
	'nsf_status_code',
	'comment'];
# NOTIFY_PROJECT_CREATE
@RequiredFields[1]=['partner_psn', 'alloc_type', 'su_alloc', 
	'last_name', 'first_name', 'middle_name', 'partner_id', 'email',
	'start_date', 'end_date', 'project_title', 'pfos', 'sfos',
	'title', 'organization', 'citizenship', 'country_access',
	'mach_num'];
@OptionalFields[1]=['ssn', 'alliance_psn',
	'grant_num', 'abstract', 
	'sector', 'qualifications', 'methodologies', 'support',
	'other_resources', 'statement_work', 'background', 'justification',
        'deliverables', 'milestones', 'progress', 'facilities', 'languages',
	'applications', 'diskspace', 'memory', 'processors', 
	'dn', 'off_address', 'str_address', 'str_address2',
	'city', 'state', 'zip', 'country',
	'bus_phone', 'bus_ext', 'bus_com',
	'home_phone', 'home_ext', 'home_com',
	'fax', 
	'org_code', 'emp_code', 'dept', 'position',
	'nsf_status_code',
	'related_transaction_id', 'comment'];
# REQUEST_PROJECT_RESOURCES
@RequiredFields[2]=['alliance_psn','mach_num'];
@OptionalFields[2]=['su_alloc', 'alloc_change', 'end_date', 'effective_date',
	 'comment'];
# NOTIFY_PROJECT_RESOURCES
@RequiredFields[3]=['alliance_psn','mach_num'];
@OptionalFields[3]=['su_alloc', 'alloc_change', 'end_date', 'effective_date',
	 'related_transaction_id', 'comment'];
# REQUEST_PROJECT_MODIFY
@RequiredFields[4]=['alliance_psn','mach_num'];
@OptionalFields[4]=['project_title', 'pfos', 'sfos',
	'grant_num', 'abstract', 
	'sector', 'qualifications', 'methodologies', 'support',
	'other_resources', 'statement_work', 'background', 'justification',
        'deliverables', 'milestones', 'progress', 'facilities', 'languages',
	'applications', 'diskspace', 'memory', 'processors', 
	'comment'];
# NOTIFY_PROJECT_MODIFY
$Numel=$#{@RequiredFields[4]};
for($i=0;$i<=$Numel;$i++) {
    $RequiredFields[5][$i]=$RequiredFields[4][$i];
}
$Numel=$#{@OptionalFields[4]};
for($i=0;$i<=$Numel;$i++) {
    $OptionalFields[5][$i]=$OptionalFields[4][$i];
}
push @{$OptionalFields[5]},"related_transaction_id";
# REQUEST_PROJECT_INACTIVATE
@RequiredFields[6]=['alliance_psn', 'mach_num', 'reason_code'];
@OptionalFields[6]=['comment'];
# NOTIFY_PROJECT_INACTIVATE
@RequiredFields[7]=['alliance_psn', 'mach_num', 'reason_code'];
@OptionalFields[7]=['related_transaction_id', 'comment'];
# REQUEST_PROJECT_REACTIVATE
$Numel=$#{@RequiredFields[0]};
for($i=0;$i<=$Numel;$i++) {
    $RequiredFields[8][$i]=$RequiredFields[0][$i];
}
push @{$RequiredFields[8]}, "alloc_type", "reason_code";
$Numel=$#{@OptionalFields[0]};
for($i=0;$i<=$Numel;$i++) {
    $OptionalFields[8][$i]=$OptionalFields[0][$i];
}

# NOTIFY_PROJECT_REACTIVATE
$Numel=$#{@RequiredFields[1]};
for($i=0;$i<=$Numel;$i++) {
    $RequiredFields[9][$i]=$RequiredFields[1][$i];
}
push @{$RequiredFields[9]}, "alliance_psn", "alloc_type", "reason_code";
$Numel=$#{@OptionalFields[1]};
for($i=0;$i<=$Numel;$i++) {
    $OptionalFields[9][$i]=$OptionalFields[1][$i];
}

# REQUEST_ACCOUNT_CREATE
@RequiredFields[10]=['alliance_psn', 'dn', 'mach_num',
	'first_name', 'last_name', 'middle_name', 'ssn',
	'title', 'organization', 'email', 
        'citizenship', 'country_access'];
@OptionalFields[10]=['partner_psn', 'partner_id',
	'off_address', 'str_address', 'str_address2',
	'city', 'state', 'zip', 'country',
	'bus_phone', 'bus_ext', 'bus_com',
	'home_phone', 'home_ext', 'home_com',
	'fax', 
	'partner_login', 'les_login', 'req_login',
	'org_code', 'emp_code', 'dept',
	'position', 'role', 
	'kerberos', 'sc_level',
	'nsf_status_code',
	'comment'];
# NOTIFY_ACCOUNT_CREATE
@RequiredFields[11]=['alliance_psn', 'mach_num',
	'first_name', 'last_name', 'middle_name', 'partner_id',
	'title', 'organization', 'email', 
        'citizenship', 'country_access'];
$Numel=$#{@OptionalFields[10]};
for($i=0;$i<=$Numel;$i++) {
    $OptionalFields[11][$i]=$OptionalFields[10][$i];
}
push @{$OptionalFields[11]}, "ssn", "dn","related_transaction_id";
# REQUEST_ACCOUNT_INACTIVATE
@RequiredFields[12]=['alliance_psn', 'dn', 'mach_num', 
	'reason_code'];
@OptionalFields[12]=['partner_login', 'comment'];
# NOTIFY_ACCOUNT_INACTIVATE
@RequiredFields[13]=['alliance_psn', 'dn', 'mach_num',
	'reason_code'];
@OptionalFields[13]=['partner_login', 'related_transaction_id', 'comment'];
# REQUEST_ACCOUNT_REACTIVATE
$Numel=$#{@RequiredFields[10]};
for($i=0;$i<=$Numel;$i++) {
    $RequiredFields[14][$i]=$RequiredFields[10][$i];
}
push @{$RequiredFields[14]}, "reason_code";
$Numel=$#{@OptionalFields[10]};
for($i=0;$i<=$Numel;$i++) {
    $OptionalFields[14][$i]=$OptionalFields[10][$i];
}
push @{$OptionalFields[14]}, "reason_code";

# NOTIFY_ACCOUNT_REACTIVATE
$Numel=$#{@RequiredFields[11]};
for($i=0;$i<=$Numel;$i++) {
    $RequiredFields[15][$i]=$RequiredFields[11][$i];
}
push @{$RequiredFields[15]}, "dn", "reason_code";
$Numel=$#{@OptionalFields[11]};
for($i=0;$i<=$Numel;$i++) {
    $OptionalFields[15][$i]=$OptionalFields[11][$i];
}

# REQUEST_USER_SUSPEND
@RequiredFields[16]=['dn', 'reason_code'];
@OptionalFields[16]=['comment'];
# NOTIFY_USER_SUSPEND
@RequiredFields[17]=['dn', 'reason_code'];
@OptionalFields[17]=['related_transaction_id', 'comment'];
# REQUEST_USER_REACTIVATE
@RequiredFields[18]=['dn', 'reason_code'];
@OptionalFields[18]=['comment'];
# NOTIFY_USER_REACTIVATE
@RequiredFields[19]=['dn', 'reason_code'];
@OptionalFields[19]=['related_transaction_id', 'comment'];
# REQUEST_USER_MODIFY
@RequiredFields[20]=['dn'];
@OptionalFields[20]=['partner_id', 'ssn', 'partner_login', 'email',
	'last_name', 'first_name', 'middle_name',
	'title', 'organization',
	'off_address', 'str_address', 'str_address2',
	'city', 'state', 'zip', 'country',
	'bus_phone', 'bus_ext', 'bus_com',
	'home_phone', 'home_ext', 'home_com',
	'fax', 'les_login', 'citizenship', 'country_access',
	'org_code', 'emp_code', 'dept', 'position',
	'kerberos', 'sc_level', 
	'new_dn', 'valid_cert',
	'comment'];
# NOTIFY_USER_MODIFY
$Numel=$#{@RequiredFields[20]};
for($i=0;$i<=$Numel;$i++) {
    $RequiredFields[21][$i]=$RequiredFields[20][$i];
}
push @{$RequiredFields[21]},"related_transaction_id";
$Numel=$#{@OptionalFields[20]};
for($i=0;$i<=$Numel;$i++) {
    $OptionalFields[21][$i]=$OptionalFields[20][$i];
}

# INFORM_PROJECT
@RequiredFields[22]=['alliance_psn', 'mach_num'];
@OptionalFields[22]=['reason_code', 'comment'];
# INFORM_ACCOUNT
@RequiredFields[23]=['alliance_psn', 'dn', 'mach_num'];
@OptionalFields[23]=['reason_code', 'comment'];
# INFORM_TRANSACTION_COMPLETE
@RequiredFields[24]=['related_transaction_id', 'related_transaction_type',
		     'status_code', 'detail_code', 'message'];
@OptionalFields[24]=['alliance_psn', 'dn', 'comment'];
# NOTIFY_PROJECT_USAGE
@RequiredFields[25]=[];
@OptionalFields[25]=[];

